
	set: function(key, val, options) {
		if (key == null) return this;

		if (typeof key == 'object') {
			attrs = key;
			options = val;
		} else {
			(attrs = {})[key] = val;
		}

		return set.call(this, this.unflatten(attrs), options);
	},

	// pick nested attributes
	flatten: function(attrs, keys) {
		attrs = this.unflatten(attrs);

		var result = {};

		_.each(keys, function(key) {
			var path = key.split('.'),
				val = attrs;

			while (path.length) {
				var attr = path.shift();

				if (!_.has(val, attr)) return;

				val = val[attr];
			}

			result[key] = val;
		});

		return result;
	},

	// return an unflattened copy of attrs
	// merging dot-delimited attributes with nested attributes in this.attributes
	unflatten: function(attrs) {
		var result = {},
			attributes = this.attributes;

		for (var attr in attrs) {
			var val = attrs[attr],
				path = attr.split('.');

			if (path.length > 1) {
				attr = path.pop();

				var obj = _.reduce(path, makeNested, result);

				if (obj[attr] !== val)
					obj[attr] = val;
			} else {
				result[attr] = val;
			}
		}

		function makeNested(obj, key, level) {
			var attrs = (level || _.has(obj, key) ? obj : attributes)[key];

			obj = obj[key] = {};

			_.some(attrs, function(val, key) {
				// check that we are not iterating an array-like object
				if (typeof key == 'number') return true;
				obj[key] = val;
			});

			return obj;
		}

		return result;
	},

